Index: issm/trunk/src/c/solvers/solver_nonlinear.cpp
===================================================================
--- issm/trunk/src/c/solvers/solver_nonlinear.cpp	(revision 13405)
+++ issm/trunk/src/c/solvers/solver_nonlinear.cpp	(revision 13975)
@@ -23,6 +23,6 @@
 	Vector<IssmDouble>* df  = NULL;
 	Vector<IssmDouble>* ys  = NULL;
-	
-	Loads* loads=NULL;
+
+	Loads* savedloads=NULL;
 	bool converged;
 	int constraints_converged;
@@ -33,5 +33,5 @@
 	int min_mechanical_constraints;
 	int max_nonlinear_iterations;
-	int  configuration_type;
+	int configuration_type;
 
 	/*Recover parameters: */
@@ -39,9 +39,10 @@
 	femmodel->parameters->FindParam(&max_nonlinear_iterations,DiagnosticMaxiterEnum);
 	femmodel->parameters->FindParam(&configuration_type,ConfigurationTypeEnum);
-	UpdateConstraintsx(femmodel->nodes,femmodel->constraints,femmodel->parameters);
+	femmodel->UpdateConstraintsx();
 
 	/*Were loads requested as output? : */
-	if(conserve_loads) loads=(Loads*)femmodel->loads->Copy(); //protect loads from being modified by the solution
-	else               loads=(Loads*)femmodel->loads;         //modify loads  in this solution
+	if(conserve_loads){
+		savedloads = static_cast<Loads*>(femmodel->loads->Copy());
+	}
 
 	count=1;
@@ -49,5 +50,5 @@
 
 	/*Start non-linear iteration using input velocity: */
-	GetSolutionFromInputsx(&ug, femmodel->elements, femmodel->nodes, femmodel->vertices, loads, femmodel->materials, femmodel->parameters);
+	GetSolutionFromInputsx(&ug, femmodel->elements, femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials, femmodel->parameters);
 	Reducevectorgtofx(&uf, ug, femmodel->nodes,femmodel->parameters);
 
@@ -62,5 +63,5 @@
 		xdelete(&old_uf);old_uf=uf;
 
-		SystemMatricesx(&Kff, &Kfs, &pf, &df, NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,loads,femmodel->materials,femmodel->parameters);
+		femmodel->SystemMatricesx(&Kff, &Kfs, &pf, &df, NULL);
 		CreateNodalConstraintsx(&ys,femmodel->nodes,configuration_type);
 		Reduceloadx(pf, Kfs, ys); xdelete(&Kfs);
@@ -72,5 +73,5 @@
 		InputUpdateFromSolutionx( femmodel->elements,femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,ug);
 
-		ConstraintsStatex(&constraints_converged, &num_unstable_constraints, femmodel->elements,femmodel->nodes,femmodel->vertices,loads,femmodel->materials,femmodel->parameters);
+		ConstraintsStatex(&constraints_converged, &num_unstable_constraints, femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
 		if(VerboseConvergence()) _pprintLine_("   number of unstable constraints: " << num_unstable_constraints);
 
@@ -108,5 +109,8 @@
 
 	/*clean-up*/
-	if(conserve_loads) delete loads;
+	if(conserve_loads){
+		delete femmodel->loads;
+		femmodel->loads=savedloads;
+	}
 	xdelete(&uf);
 	xdelete(&ug);
Index: issm/trunk/src/c/solvers/solver_stokescoupling_nonlinear.cpp
===================================================================
--- issm/trunk/src/c/solvers/solver_stokescoupling_nonlinear.cpp	(revision 13405)
+++ issm/trunk/src/c/solvers/solver_stokescoupling_nonlinear.cpp	(revision 13975)
@@ -14,21 +14,19 @@
 
 	/*intermediary: */
-	Matrix<IssmDouble>*  Kff_horiz = NULL;
-	Matrix<IssmDouble>* Kfs_horiz   = NULL;
-	Vector<IssmDouble>*  ug_horiz  = NULL;
-	Vector<IssmDouble>*  uf_horiz  = NULL;
-	Vector<IssmDouble>*  old_uf_horiz = NULL;
-	Vector<IssmDouble>*  pf_horiz  = NULL;
-	Vector<IssmDouble>*  df_horiz  = NULL;
-	Matrix<IssmDouble>*  Kff_vert  = NULL;
-	Matrix<IssmDouble>*  Kfs_vert  = NULL;
-	Vector<IssmDouble>*  ug_vert   = NULL;
-	Vector<IssmDouble>*  uf_vert   = NULL;
-	Vector<IssmDouble>*  pf_vert   = NULL;
-	Vector<IssmDouble>*  df_vert   = NULL;
-	Vector<IssmDouble>*  ys   = NULL;
+	Matrix<IssmDouble> *Kff_horiz    = NULL;
+	Matrix<IssmDouble> *Kfs_horiz    = NULL;
+	Vector<IssmDouble> *ug_horiz     = NULL;
+	Vector<IssmDouble> *uf_horiz     = NULL;
+	Vector<IssmDouble> *old_uf_horiz = NULL;
+	Vector<IssmDouble> *pf_horiz     = NULL;
+	Vector<IssmDouble> *df_horiz     = NULL;
+	Matrix<IssmDouble> *Kff_vert     = NULL;
+	Matrix<IssmDouble> *Kfs_vert     = NULL;
+	Vector<IssmDouble> *ug_vert      = NULL;
+	Vector<IssmDouble> *uf_vert      = NULL;
+	Vector<IssmDouble> *pf_vert      = NULL;
+	Vector<IssmDouble> *df_vert      = NULL;
+	Vector<IssmDouble> *ys           = NULL;
 	bool converged;
-	int  constraints_converged;
-	int  num_unstable_constraints;
 	int  count;
 
@@ -41,6 +39,6 @@
 	femmodel->parameters->FindParam(&min_mechanical_constraints,DiagnosticRiftPenaltyThresholdEnum);
 	femmodel->parameters->FindParam(&max_nonlinear_iterations,DiagnosticMaxiterEnum);
-	UpdateConstraintsx(femmodel->nodes,femmodel->constraints,femmodel->parameters);
-	
+	femmodel->UpdateConstraintsx();
+
 	count=1;
 	converged=false;
@@ -56,5 +54,5 @@
 		femmodel->SetCurrentConfiguration(DiagnosticHorizAnalysisEnum);
 		femmodel->parameters->FindParam(&configuration_type,ConfigurationTypeEnum);
-	
+
 		//Update once again the solution to make sure that vx and vxold are similar (for next step in transient or steadystate)
 		InputUpdateFromSolutionx(femmodel->elements,femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,ug_horiz);
@@ -65,5 +63,5 @@
 
 		/*solve: */
-		SystemMatricesx(&Kff_horiz, &Kfs_horiz, &pf_horiz, &df_horiz, NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+		femmodel->SystemMatricesx(&Kff_horiz, &Kfs_horiz, &pf_horiz, &df_horiz, NULL);
 		CreateNodalConstraintsx(&ys,femmodel->nodes,configuration_type);
 		Reduceloadx(pf_horiz, Kfs_horiz, ys); xdelete(&Kfs_horiz);
@@ -77,7 +75,7 @@
 		femmodel->SetCurrentConfiguration(DiagnosticVertAnalysisEnum);
 		femmodel->parameters->FindParam(&configuration_type,ConfigurationTypeEnum);
-		
+
 		/*solve: */
-		SystemMatricesx(&Kff_vert, &Kfs_vert, &pf_vert,  &df_vert,NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+		femmodel->SystemMatricesx(&Kff_vert, &Kfs_vert, &pf_vert,  &df_vert,NULL);
 		CreateNodalConstraintsx(&ys,femmodel->nodes,configuration_type);
 		Reduceloadx(pf_vert, Kfs_vert, ys); xdelete(&Kfs_vert);
Index: issm/trunk/src/c/solvers/solver_thermal_nonlinear.cpp
===================================================================
--- issm/trunk/src/c/solvers/solver_thermal_nonlinear.cpp	(revision 13405)
+++ issm/trunk/src/c/solvers/solver_thermal_nonlinear.cpp	(revision 13975)
@@ -36,5 +36,4 @@
 	int  configuration_type;
 
-
 	/*Recover parameters: */
 	kflag=1; pflag=1;
@@ -50,9 +49,9 @@
 	InputUpdateFromConstantx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,true,ResetPenaltiesEnum);
 	InputUpdateFromConstantx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,false,ConvergedEnum);
-	UpdateConstraintsx(femmodel->nodes,femmodel->constraints,femmodel->parameters);
+	femmodel->UpdateConstraintsx();
 
 	for(;;){
 
-		SystemMatricesx(&Kff, &Kfs, &pf,&df, &melting_offset,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+		femmodel->SystemMatricesx(&Kff, &Kfs, &pf,&df, &melting_offset);
 		CreateNodalConstraintsx(&ys,femmodel->nodes,configuration_type);
 		Reduceloadx(pf, Kfs, ys); xdelete(&Kfs); xdelete(&tf);
@@ -76,5 +75,5 @@
 
 		InputUpdateFromConstantx( femmodel->elements,femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,converged,ConvergedEnum);
-		
+
 		if(converged)break;
 	}
Index: issm/trunk/src/c/toolkits/issm/SeqMat.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/SeqMat.h	(revision 13405)
+++ issm/trunk/src/c/toolkits/issm/SeqMat.h	(revision 13975)
@@ -30,5 +30,5 @@
 
 	public:
-	
+
 		int M,N; 
 		doubletype* matrix;  /*here, doubletype is either IssmDouble or IssmPDouble*/
@@ -61,8 +61,15 @@
 		}
 		/*}}}*/
+		/*FUNCTION SeqMat(int m,int n,int M,int N,int* d_nnz,int* o_nnz){{{*/
+		SeqMat(int m,int n,int pM,int pN,int* d_nnz,int* o_nnz){
+
+			this->M=pM;
+			this->N=pN;
+			this->matrix=NULL;
+			if(pM*pN) this->matrix=xNewZeroInit<doubletype>(pM*pN);
+		}
+		/*}}}*/
 		/*FUNCTION SeqMat(doubletype* serial_mat,int M,int N,doubletype sparsity){{{*/
 		SeqMat(doubletype* serial_mat,int pM,int pN,doubletype sparsity){
-
-			int i,j;
 
 			this->M=pM;
Index: issm/trunk/src/c/toolkits/issm/SeqVec.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/SeqVec.h	(revision 13405)
+++ issm/trunk/src/c/toolkits/issm/SeqVec.h	(revision 13975)
@@ -29,5 +29,5 @@
 
 	public:
-	
+
 		doubletype* vector;
 		int M;
@@ -49,4 +49,12 @@
 		}
 		/*}}}*/
+		/*FUNCTION SeqVec(int m,int M){{{*/
+		SeqVec(int pm,int pM){
+
+			this->M=pM;
+			this->vector=NULL;
+			if(this->M) this->vector=xNewZeroInit<doubletype>(pM);
+		}
+		/*}}}*/
 		/*FUNCTION SeqVec(int M,bool fromlocalsize){{{*/
 		SeqVec(int pM,bool fromlocalsize){
@@ -59,6 +67,4 @@
 		/*FUNCTION SeqVec(doubletype* serial_vec,int M){{{*/
 		SeqVec(doubletype* buffer,int pM){
-
-			int i,j;
 
 			this->M=pM;
Index: issm/trunk/src/c/toolkits/mpi/mpiincludes.h
===================================================================
--- issm/trunk/src/c/toolkits/mpi/mpiincludes.h	(revision 13405)
+++ issm/trunk/src/c/toolkits/mpi/mpiincludes.h	(revision 13975)
@@ -7,5 +7,5 @@
 
 /*MPI includes: */
-#include "mpi.h"
+#include <mpi.h>
 
 /*Patches: */
Index: issm/trunk/src/c/toolkits/mpi/patches/DetermineLocalSize.cpp
===================================================================
--- issm/trunk/src/c/toolkits/mpi/patches/DetermineLocalSize.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/mpi/patches/DetermineLocalSize.cpp	(revision 13975)
@@ -6,6 +6,7 @@
 #include <math.h>
 #include "../../../shared/shared.h"
+#include "../../../include/types.h"
 
-int DetermineLocalSize(int global_size){
+int DetermineLocalSize(int global_size,COMM comm){
 
 	/*output: */
@@ -18,7 +19,11 @@
 
 	/*from MPI: */
-	extern int num_procs;
-	extern int my_rank;
-	
+	int num_procs;
+	int my_rank;
+
+	/*recover my_rank*/
+	MPI_Comm_rank(comm,&my_rank);
+	MPI_Comm_size(comm,&num_procs);
+
 	/*We are  not bound by any library, just use what seems most logical*/
 	num_local_rows=xNew<int>(num_procs);    
@@ -30,5 +35,5 @@
 		num_local_rows[i]=(int)floor((double)global_size/(double)num_procs); 
 	}
-	
+
 	/*There may be some rows left. Distribute evenly.*/ 
 	row_rest=global_size - num_procs*(int)floor((double)global_size/(double)num_procs);
@@ -37,5 +42,5 @@
 	}
 	local_size=num_local_rows[my_rank];
-	
+
 	/*free ressources: */
 	xDelete<int>(num_local_rows);
Index: issm/trunk/src/c/toolkits/mpi/patches/mpipatches.h
===================================================================
--- issm/trunk/src/c/toolkits/mpi/patches/mpipatches.h	(revision 13405)
+++ issm/trunk/src/c/toolkits/mpi/patches/mpipatches.h	(revision 13975)
@@ -3,16 +3,10 @@
  */
 
-
 #ifndef MPI_PATCHES_H_ 
 #define MPI_PATCHES_H_
 
+#include "../../../include/types.h"
 
-int MPI_Boundariesfromrange(int* plower_row, int* pupper_row,int range);
-int MPI_Lowerrow(int n);
-int MPI_Upperrow(int n);
-int DetermineLocalSize(int global_size);
-
-
-
+int DetermineLocalSize(int global_size,COMM comm);
 
 #endif
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscMat.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscMat.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscMat.cpp	(revision 13975)
@@ -31,5 +31,5 @@
 PetscMat::PetscMat(int M,int N){
 
-	this->matrix=NewMat(M,N);
+	this->matrix=NewMat(M,N,IssmComm::GetComm());
 }
 /*}}}*/
@@ -37,8 +37,19 @@
 PetscMat::PetscMat(int M,int N, IssmDouble sparsity){
 
-	this->matrix=NewMat(M,N,sparsity);
+	this->matrix=NewMat(M,N,sparsity,IssmComm::GetComm());
 }
 /*}}}*/
-/*FUNCTION PetscMat(IssmDouble* serial_mat,int M,int N,IssmDouble sparsity){{{*/
+/*FUNCTION PetscMat::PetscMat(int m,int n,int M,int N,int* d_nnz,int* o_nnz){{{*/
+PetscMat::PetscMat(int m,int n,int M,int N,int* d_nnz,int* o_nnz){
+
+	MatCreate(IssmComm::GetComm(),&this->matrix);
+	MatSetSizes(this->matrix,m,n,M,N);
+	MatSetFromOptions(this->matrix);
+	MatMPIAIJSetPreallocation(this->matrix,0,d_nnz,0,o_nnz);
+	//MatSetOption(this->matrix,MAT_NEW_NONZERO_ALLOCATION_ERR,PETSC_FALSE);
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::PetscMat(IssmDouble* serial_mat,int M,int N,IssmDouble sparsity){{{*/
 PetscMat::PetscMat(IssmDouble* serial_mat,int M,int N,IssmDouble sparsity){
 
@@ -46,5 +57,5 @@
 	int* idxm=NULL;
 	int* idxn=NULL;
-	
+
 	if(M)idxm=xNew<int>(M);
 	if(N)idxn=xNew<int>(N);
@@ -53,6 +64,5 @@
 	for(i=0;i<N;i++)idxn[i]=i;
 
-
-	this->matrix=NewMat(M,N,sparsity);
+	this->matrix=NewMat(M,N,sparsity,IssmComm::GetComm());
 	MatSetValues(this->matrix,M,idxm,N,idxn,serial_mat,INSERT_VALUES);
 	MatAssemblyBegin(this->matrix,MAT_FINAL_ASSEMBLY);
@@ -66,6 +76,6 @@
 /*FUNCTION PetscMat::PetscMat(int M,int N, int connectivity, int numberofdofspernode){{{*/
 PetscMat::PetscMat(int M,int N, int connectivity,int numberofdofspernode){
-	
-	this->matrix=NewMat(M,N,connectivity,numberofdofspernode);
+
+	this->matrix=NewMat(M,N,connectivity,numberofdofspernode,IssmComm::GetComm());
 
 }
@@ -78,4 +88,18 @@
 
 /*PetscMat specific routines: */
+/*FUNCTION PetscMat::AllocationInfo{{{*/
+void PetscMat::AllocationInfo(void){
+
+	MatInfo info;
+	MatGetInfo(this->matrix,MAT_GLOBAL_SUM,&info);
+	_pprintLine_("=========================== Stiffness matrix allocation info ===========================");
+	_pprintLine_("");
+	_pprintLine_(" nz_allocated: "<<info.nz_allocated);
+	_pprintLine_(" nz_used     : "<<info.nz_used);
+	_pprintLine_(" nz_unneeded : "<<info.nz_unneeded<<" ("<<double(info.nz_unneeded)/double(info.nz_allocated)*100.<<"%)");
+	_pprintLine_("");
+	_pprintLine_("========================================================================================");
+}
+/*}}}*/
 /*FUNCTION PetscMat::Echo{{{*/
 void PetscMat::Echo(void){
@@ -90,7 +114,4 @@
 	MatAssemblyBegin(this->matrix,MAT_FINAL_ASSEMBLY);
 	MatAssemblyEnd(this->matrix,MAT_FINAL_ASSEMBLY);
-	#if _PETSC_MAJOR_ == 2 
-		MatCompress(this->matrix);
-	#endif
 
 }
@@ -99,9 +120,8 @@
 IssmDouble PetscMat::Norm(NormMode mode){
 
-
 	IssmDouble norm=0;
 	_assert_(this->matrix);
 	MatNorm(this->matrix,ISSMToPetscNormMode(mode),&norm);
-	
+
 	return norm;
 
@@ -128,5 +148,5 @@
 	_assert_(this->matrix);
 	_assert_(X->vector);
-	MatMultPatch(this->matrix,X->vector,AX->vector);
+	MatMultPatch(this->matrix,X->vector,AX->vector,IssmComm::GetComm());
 
 }
@@ -135,7 +155,5 @@
 PetscMat* PetscMat::Duplicate(void){
 
-	PetscMat* output=NULL;
-
-	output=new PetscMat();
+	PetscMat* output=new PetscMat();
 	_assert_(this->matrix);
 	MatDuplicate(this->matrix,MAT_COPY_VALUES,&output->matrix);
@@ -150,5 +168,5 @@
 	 IssmDouble* output=NULL;
 
-	 MatToSerial(&output,this->matrix);
+	 MatToSerial(&output,this->matrix,IssmComm::GetComm());
 	 return output;
 
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscMat.h
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscMat.h	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscMat.h	(revision 13975)
@@ -31,13 +31,15 @@
 		#endif
 
-		/*PetscMat constructors, destructors {{{*/
+		/*PetscMat constructors, destructors*/
 		PetscMat();
 		PetscMat(int M,int N);
 		PetscMat(int M,int N,IssmDouble sparsity);
+		PetscMat(int m,int n,int M,int N,int* d_nnz,int* o_nnz);
 		PetscMat(IssmDouble* serial_mat,int M,int N,IssmDouble sparsity);
 		PetscMat(int M,int N,int connectivity,int numberofdofspernode);
 		~PetscMat();
-		/*}}}*/
-		/*PetscMat specific routines {{{*/
+
+		/*PetscMat specific routines*/
+		void AllocationInfo(void);
 		void Echo(void);
 		void Assemble(void);
@@ -50,7 +52,5 @@
 		void SetValues(int m,int* idxm,int n,int* idxn,IssmDouble* values,InsMode mode);
 		void Convert(MatrixType type);
-		/*}}}*/
+};
 
-};
-		
 #endif //#ifndef _PETSCMAT_H_
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscVec.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscVec.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscVec.cpp	(revision 13975)
@@ -29,6 +29,16 @@
 /*FUNCTION PetscVec::PetscVec(int M,bool fromlocalsize){{{*/
 PetscVec::PetscVec(int M,bool fromlocalsize){
-	
-	this->vector=NewVec(M,fromlocalsize);
+
+	this->vector=NewVec(M,IssmComm::GetComm(),fromlocalsize);
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::PetscVec(int m,int M){{{*/
+PetscVec::PetscVec(int m,int M){
+
+	VecCreate(IssmComm::GetComm(),&this->vector);
+	VecSetSizes(this->vector,m,M);
+	VecSetFromOptions(this->vector);
+	VecSet(this->vector,0.0);
 
 }
@@ -38,5 +48,5 @@
 
 	if(petsc_vec==NULL){
-		this->vector=NewVec(0);
+		this->vector=NewVec(0,IssmComm::GetComm());
 	}
 	else{
@@ -55,5 +65,5 @@
 	for(int i=0;i<M;i++) idxm[i]=i;
 
-	this->vector=NewVec(M);
+	this->vector=NewVec(M,IssmComm::GetComm());
 	VecSetValues(this->vector,M,idxm,serial_vec,INSERT_VALUES);
 	VecAssemblyBegin(this->vector);
@@ -79,5 +89,5 @@
 /*FUNCTION PetscVec::Assemble{{{*/
 void PetscVec::Assemble(void){
-		
+
 	_assert_(this->vector);
 	VecAssemblyBegin(this->vector); 
@@ -88,5 +98,5 @@
 /*FUNCTION PetscVec::SetValues{{{*/
 void PetscVec::SetValues(int ssize, int* list, IssmDouble* values, InsMode mode){
-	
+
 	_assert_(this->vector);
 	VecSetValues(this->vector,ssize,list,values,ISSMToPetscInsertMode(mode));
@@ -128,10 +138,9 @@
 /*FUNCTION PetscVec::Duplicate{{{*/
 PetscVec* PetscVec::Duplicate(void){
-	
-	PetscVec* output=NULL;
+
 	_assert_(this->vector);
 	Vec vec_output=NULL;
 	VecDuplicate(this->vector,&vec_output);
-	output=new PetscVec(vec_output);
+	PetscVec* output=new PetscVec(vec_output);
 	VecFree(&vec_output);
 
@@ -165,7 +174,7 @@
 /*FUNCTION PetscVec::ToMPISerial{{{*/
 IssmDouble* PetscVec::ToMPISerial(void){
-	
+
 	IssmDouble* vec_serial=NULL;
-	VecToMPISerial(&vec_serial, this->vector);
+	VecToMPISerial(&vec_serial, this->vector,IssmComm::GetComm());
 	return vec_serial;
 
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscVec.h
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscVec.h	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscVec.h	(revision 13975)
@@ -19,5 +19,4 @@
 #include "../../../include/include.h"
 
-
 /*}}}*/
 
@@ -31,13 +30,13 @@
 		#endif
 
-
-		/*PetscVec constructors, destructors {{{*/
+		/*PetscVec constructors, destructors*/
 		PetscVec();
 		PetscVec(int M,bool fromlocalsize=false);
+		PetscVec(int m,int M);
 		PetscVec(IssmDouble* buffer, int M);
 		PetscVec(Vec petsc_vec);
 		~PetscVec();
-		/*}}}*/
-		/*PetscVec specific routines {{{*/
+
+		/*PetscVec specific routines*/
 		void Echo(void);
 		void Assemble(void);
@@ -57,5 +56,4 @@
 		void PointwiseDivide(PetscVec* x,PetscVec* y);
 		IssmDouble Dot(PetscVec* vector);
-		/*}}}*/
 };
 
Index: issm/trunk/src/c/toolkits/petsc/patches/GetOwnershipBoundariesFromRange.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/GetOwnershipBoundariesFromRange.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/GetOwnershipBoundariesFromRange.cpp	(revision 13975)
@@ -3,5 +3,4 @@
  *  lower row and upper row from a matrix a cpu owns.
  */
-
 
 #ifdef HAVE_CONFIG_H
@@ -14,25 +13,25 @@
 #include "../../../shared/shared.h"
 
-void GetOwnershipBoundariesFromRange(int* plower_row,int* pupper_row,int range){
+void GetOwnershipBoundariesFromRange(int* plower_row,int* pupper_row,int range,COMM comm){
 
 	/*externals :*/
-	extern int my_rank;
-	extern int num_procs;
-	
+	int my_rank;
+	int num_procs;
+
+	/*recover my_rank and num_procs:*/
+	MPI_Comm_size(comm,&num_procs);
+	MPI_Comm_rank(comm,&my_rank);
+
 	/*output: */
 	int lower_row,upper_row;
-	
-	/*intermediary :*/
-	int i;
-	int* allranges=NULL;
 
 	/*Gather all range values into allranges, for all nodes*/
-	allranges=xNew<int>(num_procs);
-	MPI_Allgather(&range,1,MPI_INT,allranges,1,MPI_INT,MPI_COMM_WORLD);
+	int* allranges=xNew<int>(num_procs);
+	MPI_Allgather(&range,1,MPI_INT,allranges,1,MPI_INT,comm);
 
 	/*From all ranges, get lower row and upper row*/
 	lower_row=0;
 	upper_row=lower_row+allranges[0];
-	for (i=1;i<=my_rank;i++){
+	for(int i=1;i<=my_rank;i++){
 		lower_row=lower_row+allranges[i-1];
 		upper_row=upper_row+allranges[i];
Index: issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscInsertMode.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscInsertMode.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscInsertMode.cpp	(revision 13975)
@@ -2,5 +2,4 @@
  * \brief: convert InsertMode from ISSM to Petsc
  */
-
 
 #ifdef HAVE_CONFIG_H
@@ -11,12 +10,11 @@
 
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
+#include <petscmat.h>
+#include <petscvec.h>
+#include <petscksp.h>
 
 /*ISSM includes: */
 #include "../../toolkitsenums.h"
 #include "../../../shared/shared.h"
-
 
 InsertMode ISSMToPetscInsertMode(InsMode mode){
Index: issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscMatrixType.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscMatrixType.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscMatrixType.cpp	(revision 13975)
@@ -2,5 +2,4 @@
  * \brief: convert MatrixType from ISSM to Petsc
  */
-
 
 #ifdef HAVE_CONFIG_H
@@ -11,7 +10,7 @@
 
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
+#include <petscmat.h>
+#include <petscvec.h>
+#include <petscksp.h>
 
 /*ISSM includes: */
@@ -19,6 +18,5 @@
 #include "../../../shared/shared.h"
 
-
-MatType ISSMToPetscMatrixType(MatrixType type){
+const MatType ISSMToPetscMatrixType(MatrixType type){
 
 	switch(type){
Index: issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscNormMode.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscNormMode.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscNormMode.cpp	(revision 13975)
@@ -2,5 +2,4 @@
  * \brief: convert NormMode from ISSM to Petsc
  */
-
 
 #ifdef HAVE_CONFIG_H
@@ -11,12 +10,11 @@
 
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
+#include <petscmat.h>
+#include <petscvec.h>
+#include <petscksp.h>
 
 /*ISSM includes: */
 #include "../../toolkitsenums.h"
 #include "../../../shared/shared.h"
-
 
 NormType ISSMToPetscNormMode(NormMode mode){
Index: issm/trunk/src/c/toolkits/petsc/patches/KSPFree.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/KSPFree.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/KSPFree.cpp	(revision 13975)
@@ -9,9 +9,8 @@
 #endif
 
-
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
+#include <petscmat.h>
+#include <petscvec.h>
+#include <petscksp.h>
 
 void KSPFree(KSP* pksp){
@@ -26,3 +25,2 @@
 
 }
-
Index: issm/trunk/src/c/toolkits/petsc/patches/MatFree.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/MatFree.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/MatFree.cpp	(revision 13975)
@@ -9,9 +9,8 @@
 #endif
 
-
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscmat.h"
-#include "petscksp.h"
+#include <petscmat.h>
+#include <petscmat.h>
+#include <petscksp.h>
 
 void MatFree(Mat* pmat){
@@ -26,3 +25,2 @@
 
 }
-
Index: issm/trunk/src/c/toolkits/petsc/patches/MatMultPatch.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/MatMultPatch.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/MatMultPatch.cpp	(revision 13975)
@@ -10,15 +10,15 @@
 
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
+#include <petscmat.h>
+#include <petscvec.h>
+#include <petscksp.h>
 
 #include "../../../shared/shared.h"
 
 /*Function prototypes: */
-int MatMultCompatible(Mat A,Vec x);
-void VecRelocalize(Vec* outvector,Vec vector,int m);
+int MatMultCompatible(Mat A,Vec x,COMM comm);
+void VecRelocalize(Vec* outvector,Vec vector,int m,COMM comm);
 
-void MatMultPatch(Mat A,Vec X, Vec AX){ //same prototype as MatMult in Petsc
+void MatMultPatch(Mat A,Vec X, Vec AX,COMM comm){ //same prototype as MatMult in Petsc
 
 	int m,n;
@@ -27,10 +27,10 @@
 	_assert_(A); _assert_(X);
 
-	if (MatMultCompatible(A,X)){
+	if (MatMultCompatible(A,X,comm)){
 		MatMult(A,X,AX); 
 	}
 	else{
 		MatGetLocalSize(A,&m,&n);;
-		VecRelocalize(&X_rel,X,n);
+		VecRelocalize(&X_rel,X,n,comm);
 		MatMult(A,X_rel,AX); ;
 		#if _PETSC_MAJOR_ < 3 || (_PETSC_MAJOR_ == 3 && _PETSC_MINOR_ < 2)
@@ -42,22 +42,25 @@
 }
 
-int MatMultCompatible(Mat A,Vec x){
-	
+int MatMultCompatible(Mat A,Vec x,COMM comm){
+
 	/*error management*/
-	
+
 	int local_m,local_n;
-	int lower_row,upper_row,range;
+	int range;
 	int result=1;
 	int sumresult;
-	extern int num_procs;
+	int num_procs;
+
+	/*recover num_procs:*/
+	MPI_Comm_size(comm,&num_procs);
 
 	MatGetLocalSize(A,&local_m,&local_n);;
 	VecGetLocalSize(x,&range);;
-	
+
 	if (local_n!=range)result=0;
-	
+
 	/*synchronize result: */
-	MPI_Reduce (&result,&sumresult,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD );
-	MPI_Bcast(&sumresult,1,MPI_INT,0,MPI_COMM_WORLD);                
+	MPI_Reduce (&result,&sumresult,1,MPI_INT,MPI_SUM,0,comm );
+	MPI_Bcast(&sumresult,1,MPI_INT,0,comm);                
 	if (sumresult!=num_procs){
 		result=0;
@@ -69,5 +72,5 @@
 }
 
-void VecRelocalize(Vec* poutvector,Vec vector,int m){
+void VecRelocalize(Vec* poutvector,Vec vector,int m,COMM comm){
 
 	/*vector index and vector values*/
@@ -78,7 +81,7 @@
 	/*output: */
 	Vec outvector=NULL;
-	
+
 	/*Create outvector with local size m*/
-	VecCreate(PETSC_COMM_WORLD,&outvector); ; 
+	VecCreate(comm,&outvector); ; 
 	VecSetSizes(outvector,m,PETSC_DECIDE); ; 
 	VecSetFromOptions(outvector); ; 
Index: issm/trunk/src/c/toolkits/petsc/patches/MatToSerial.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/MatToSerial.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/MatToSerial.cpp	(revision 13975)
@@ -9,14 +9,13 @@
 #endif
 
-
 #include "../petscincludes.h"
 #include "../../../shared/shared.h"
 
-void MatToSerial(double** poutmatrix,Mat matrix){
+void MatToSerial(double** poutmatrix,Mat matrix,COMM comm){
 
 	int i;
-	extern int my_rank;
-	extern int num_procs;
-	
+	int my_rank;
+	int num_procs;
+
 	/*Petsc variables*/
 	PetscInt lower_row,upper_row; 
@@ -28,8 +27,12 @@
 	double* local_matrix=NULL; /*matrix local to each node used for temporary holding matrix values*/
 	int buffer[3];
-	
+
+	/*recover my_rank and num_procs:*/
+	MPI_Comm_size(comm,&num_procs);
+	MPI_Comm_rank(comm,&my_rank);
+
 	/*Output*/
 	double* outmatrix=NULL;
-	
+
 	/*get matrix size: */
 	MatGetSize(matrix,&M,&N);
@@ -39,13 +42,13 @@
 	upper_row--; 
 	range=upper_row-lower_row+1;
-	
+
 	/*Local and global allocation*/
 	if (my_rank==0)outmatrix=xNew<double>(M*N);
-	
+
 	if (range){
 		local_matrix=xNew<double>(N*range);
 		idxm=xNew<int>(range);  
 		idxn=xNew<int>(N);  
-	 
+
 		for (i=0;i<N;i++){
 			*(idxn+i)=i;
@@ -54,5 +57,5 @@
 			*(idxm+i)=lower_row+i;
 		}
-	
+
 		MatGetValues(matrix,range,idxm,N,idxn,local_matrix);     
 	}
@@ -60,5 +63,5 @@
 	/*Now each node holds its local_matrix containing range rows. 
 	 * We send these rows to the matrix on node 0*/
-	
+
 	for (i=1;i<num_procs;i++){
 		if (my_rank==i){ 
@@ -66,10 +69,10 @@
 			buffer[1]=lower_row;
 			buffer[2]=range;
-			MPI_Send(buffer,3,MPI_INT,0,1,MPI_COMM_WORLD);   
-			if (range)MPI_Send(local_matrix,N*range,MPI_DOUBLE,0,1,MPI_COMM_WORLD); 
+			MPI_Send(buffer,3,MPI_INT,0,1,comm);   
+			if (range)MPI_Send(local_matrix,N*range,MPI_DOUBLE,0,1,comm); 
 		}
 		if (my_rank==0){
-			MPI_Recv(buffer,3,MPI_INT,i,1,MPI_COMM_WORLD,&status); 
-			if (buffer[2])MPI_Recv(outmatrix+(buffer[1]*N),N*buffer[2],MPI_DOUBLE,i,1,MPI_COMM_WORLD,&status);
+			MPI_Recv(buffer,3,MPI_INT,i,1,comm,&status); 
+			if (buffer[2])MPI_Recv(outmatrix+(buffer[1]*N),N*buffer[2],MPI_DOUBLE,i,1,comm,&status);
 		}
 	} 
@@ -78,5 +81,5 @@
 		memcpy(outmatrix,local_matrix,N*range*sizeof(double));
 	} 
-	
+
 	/*Assign output pointer: */
 	*poutmatrix=outmatrix;
